#include <kihon.h>

// 萔`
extern const unsigned char palette[16][16];
const unsigned char message[] = "LIBKIHON2 TEST !";

// [y[Wϐ`
typedef struct Work {
	unsigned char frame;
	char speed;
	char rad;
	char first;
	char px, py;
	char i;
	unsigned char costbl[65];
} Work;

extern Work zpw;
#pragma zpsym ("zpw");  /* zpw is in the zeropage */

// cosle[u
// -1 ` 0 ` +1  0x81 ` 0 ` 0x7f ŕ\B
// z1/4̃f[^pӂB
// RȂ琸x͈B
const unsigned char costbl[] = {
	0x7f, /*   0: 1.000000 */
	0x7e, /*   1: 0.999699 */
	0x7e, /*   2: 0.998795 */
	0x7e, /*   3: 0.997290 */
	0x7e, /*   4: 0.995185 */
	0x7e, /*   5: 0.992480 */
	0x7d, /*   6: 0.989177 */
	0x7d, /*   7: 0.985278 */
	0x7c, /*   8: 0.980785 */
	0x7b, /*   9: 0.975702 */
	0x7b, /*  10: 0.970031 */
	0x7a, /*  11: 0.963776 */
	0x79, /*  12: 0.956940 */
	0x78, /*  13: 0.949528 */
	0x77, /*  14: 0.941544 */
	0x76, /*  15: 0.932993 */
	0x75, /*  16: 0.923880 */
	0x74, /*  17: 0.914210 */
	0x72, /*  18: 0.903989 */
	0x71, /*  19: 0.893224 */
	0x70, /*  20: 0.881921 */
	0x6e, /*  21: 0.870087 */
	0x6c, /*  22: 0.857729 */
	0x6b, /*  23: 0.844854 */
	0x69, /*  24: 0.831470 */
	0x67, /*  25: 0.817585 */
	0x66, /*  26: 0.803208 */
	0x64, /*  27: 0.788346 */
	0x62, /*  28: 0.773010 */
	0x60, /*  29: 0.757209 */
	0x5e, /*  30: 0.740951 */
	0x5b, /*  31: 0.724247 */
	0x59, /*  32: 0.707107 */
	0x57, /*  33: 0.689541 */
	0x55, /*  34: 0.671559 */
	0x52, /*  35: 0.653173 */
	0x50, /*  36: 0.634393 */
	0x4e, /*  37: 0.615232 */
	0x4b, /*  38: 0.595699 */
	0x49, /*  39: 0.575808 */
	0x46, /*  40: 0.555570 */
	0x43, /*  41: 0.534998 */
	0x41, /*  42: 0.514103 */
	0x3e, /*  43: 0.492898 */
	0x3b, /*  44: 0.471397 */
	0x39, /*  45: 0.449611 */
	0x36, /*  46: 0.427555 */
	0x33, /*  47: 0.405241 */
	0x30, /*  48: 0.382683 */
	0x2d, /*  49: 0.359895 */
	0x2a, /*  50: 0.336890 */
	0x27, /*  51: 0.313682 */
	0x24, /*  52: 0.290285 */
	0x21, /*  53: 0.266713 */
	0x1e, /*  54: 0.242980 */
	0x1b, /*  55: 0.219101 */
	0x18, /*  56: 0.195090 */
	0x15, /*  57: 0.170962 */
	0x12, /*  58: 0.146730 */
	0x0f, /*  59: 0.122411 */
	0x0c, /*  60: 0.098017 */
	0x09, /*  61: 0.073565 */
	0x06, /*  62: 0.049068 */
	0x03, /*  63: 0.024541 */
	0x00, /*  64: 0.000000 */
};

void init_costbl(void) {
	for (zpw.i = 0; zpw.i < sizeof(costbl)/sizeof(costbl[0]); ++zpw.i) {
		zpw.costbl[zpw.i] = costbl[zpw.i];
	}
}

unsigned char cos(unsigned char rad) {
	if (rad < 0x40) {
		return zpw.costbl[rad];

	} else if (rad < 0x80) {
		rad = 0x80 - rad;
		return -zpw.costbl[rad];

	} else if (rad < 0xc0) {
		rad -= 0x80;
		return -zpw.costbl[rad];

	} else {
		rad = -rad;
		return zpw.costbl[rad];
	}
}

unsigned char sin(unsigned char rad) {
	rad -= 0x40;
	if (rad < 0x40) {
		return zpw.costbl[rad];

	} else if (rad < 0x80) {
		rad = 0x80 - rad;
		return -zpw.costbl[rad];

	} else if (rad < 0xc0) {
		rad -= 0x80;
		return -zpw.costbl[rad];

	} else {
		rad = -rad;
		return zpw.costbl[rad];
	}
}

// C
void NesMain(void) {
	// ϐ
	zpw.frame = 0;
	zpw.speed = 0;
	init_costbl();

	// PPȔ
	InitPPU();

	// BG̏
	FillBackground(0x20, 0x00, 0, 0);
	FillBackground(0x21, 0x00, 0, 0);
	FillBackground(0x22, 0x00, 0, 0);
	FillBackground(0x23, 0x00, 0, 0xc0);
	FillAttribute(0x23, 0xc0, 0, 64);
/*
	FillBackground(0x24, 0x00, 0, 0);
	FillBackground(0x25, 0x00, 0, 0);
	FillBackground(0x26, 0x00, 0, 0);
	FillBackground(0x27, 0x00, 0, 0xc0);
	FillAttribute(0x27, 0xc0, 0, 64);
*/
	FillBackground(0x28, 0x00, 0, 0);
	FillBackground(0x29, 0x00, 0, 0);
	FillBackground(0x2a, 0x00, 0, 0);
	FillBackground(0x2b, 0x00, 0, 0xc0);
	FillAttribute(0x2b, 0xc0, 0, 64);
/*
	FillBackground(0x2c, 0x00, 0, 0);
	FillBackground(0x2d, 0x00, 0, 0);
	FillBackground(0x2e, 0x00, 0, 0);
	FillBackground(0x2f, 0x00, 0, 0xc0);
	FillAttribute(0x2f, 0xc0, 0, 64);
*/
	//// ubNp^[̐ݒ
	FillBackground(0x23, 0x40, 6, 128);
	FillAttribute(0x23, 0xc0+48, 0x55, 16);

	//// ̐ݒ
	SetBackground(0x20, 0x89, (unsigned char *)message, sizeof(message));

	// XvCg̏
	InitDMA((unsigned char *)0x700);

	//// pbgݒ
	SetPalette((unsigned char *)palette[0], 0);
	SetPalette((unsigned char *)palette[1], 1);

	// XN[l̐ݒ
	SetScroll(0, 0);

	// `Jn(NMI荞ݖ)
	SetPPU(0x08, 0x1e);

	// C[v
	while (1) {
		// VBlank҂
		VBlank();

		// XvCg]
		SendDMA(0x07);

		// Rg[͊mF
		CheckPad();

		// vZ
		if (zpw.speed < 0x80) {
			if (ButtonDown(0, BTN_A)) {
				if (zpw.speed < 0x60) ++zpw.speed;
			} else if (ButtonDown(0, BTN_B)) {
				--zpw.speed;
			} else {
				if (zpw.speed > 0x00) --zpw.speed;
			}
		} else {
			if (ButtonDown(0, BTN_A)) {
				++zpw.speed;
			} else if (ButtonDown(0, BTN_B)) {
				if (zpw.speed > 0xa0) --zpw.speed;
			} else {
				if (zpw.speed > 0x00) ++zpw.speed;
			}
		}

		zpw.frame += zpw.speed;

		// XvCg̐ݒ
		zpw.first = 1;
		for (zpw.i = 0; zpw.i < 64; ++zpw.i) {
			zpw.rad = (zpw.i << 2) + zpw.frame;
			zpw.px = (cos(zpw.rad) >> 1) + 128;
			zpw.py = (sin(zpw.rad) >> 1) + 128;
			SetDMA((unsigned char *)0x700, zpw.first, zpw.px, zpw.py, zpw.i, 1);
			zpw.first = 0;
		}
	}
}

// NMI荞
void NMIProc(void) {
}
